#include <bits/stdc++.h>
#define endl '\n'
#define int long long

using namespace std;

int N=100000+9;

signed main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);

    int n;
    cin >> n;
    vector<int> niz(n);
    for(auto&x:niz)
        cin >> x;
    vector<int> count_bits(30,0);
    for(int i=0; i<30; i++){
        for(int j=0; j<n; j++){
            if(((1<<i)&niz[j])>0)
                count_bits[i]++;
        }
    }
    int q;
    cin >> q;
    while(q--){
        int t;
        cin >> t;
        if(t==0){
            int k;
            cin >> k;
            int rez=0;
            for(int i=0; i<30; i++){
                if(count_bits[i]>=k)
                    rez+=(1<<i);
            }
            cout << rez << endl;
        }
        else{
            int ind,x;
            cin >> ind >> x;
            ind--;
            for(int i=0; i<30; i++){
                if(((1<<i)&niz[ind])>0)
                    count_bits[i]--;
            }
            for(int i=0; i<30; i++){
                if(((1<<i)&x)>0)
                    count_bits[i]++;
            }
            niz[ind]=x;
        }
    }


    return 0;
}